Global imagelist:TList = New TList		'list of images attatched to verlet cages.  This must be a list for order issues

Type PhysicsImage
	Field c:Constraint
	Field rotationoffset:Float
	Field image:TImage
	Field alph#
	Field r:Int,g:Int,b:Int
	Field sclx#,scly#
	Field blendmode:Int
	
	Function Create:PhysicsImage(con:constraint,image:TImage,r:Int = 255,g:Int = 255,b:Int = 255,alph# = 1,sclx# = 1,scly# = 1,blend:Int = alphablend,setflg:Int = True)
		
		Local P:PhysicsImage = New PhysicsImage
		P.c:constraint = con:constraint
		P.image = image
		If setflg = True Then
			p.rotationoffset = ATan2(con.v1.x-con.v2.x,con.v1.y-con.v2.y)
		Else
			p.rotationoffset = 0
		EndIf
		
		P.r = r
		p.g = g
		p.b = b
		p.alph# = alph#
		p.sclx = sclx
		p.scly = scly
		p.blendmode = blend
		
		Imagelist.addlast(P:physicsimage)
		
		Return P:physicsimage
		
	End Function
	
	Method rotate(angle:Int)
		rotationoffset :+ angle
	End Method
	
	Method scale(sx#,sy#)
		sclx# = sx#
		scly# = sy#
	End Method
	
	Method alpha(a#)
		alph# = a#
	End Method
	
	Method blend(b:Int)
		blendmode = b
	End Method
	
	Method color(r1:Int,g1:Int,b1:Int)
		r = r1
		g = g1
		b = b1
	End Method
	
	Method remove()
		imagelist.remove(Self)
	End Method
	
End Type



Function updatephysicsimage()	'updates physics images

	Local temprotof:Float
	For Local p:physicsimage = EachIn imagelist
		SetColor p.r,p.g,p.b
		SetAlpha p.alph
		SetBlend p.blendmode
		SetScale p.sclx,p.scly
		temprotof = -(ATan2(p.c.v1.x-p.c.v2.x,p.c.v1.y-p.c.v2.y)-p.rotationoffset)
		SetRotation temprotof
		DrawImagescl p.image,(p.c.v1.x+p.c.v2.x)/2+physicsoffsetx,(p.c.v1.y+p.c.v2.y)/2+physicsoffsety
	Next
	SetRotation 0
	SetScale 1,1
	SetColor 255,255,255
	SetAlpha 1
	SetBlend alphablend
	
EndFunction

Function DrawImagescl(image:TImage,x:Float,y:Float,frame:Int = 0)

	DrawImage2 image,((x-physicsoriginx)*physicsscalex)+physicsoriginx,((y-physicsoriginy)*physicsscaley)+physicsoriginy,frame

End Function


Function drawimage2(image:TImage,x:Int,y:Int,frame:Int = 0)	'only draws onscreen images
	Local tmp:Int = ImageWidth(image)+ImageHeight(image)
	If x > -tmp And x < GraphicsWidth()+tmp And y > -tmp And y < GraphicsHeight()+tmp Then
		DrawImage image,x,y,frame
	EndIf
End Function