Global polysegcount:Int	'number of polysegments ever made
Global polysegarray:Polyseg[100]		'array for polysegs which is short for polygon segments


Type Polyseg	'polygon segment
	Field index:Int
	Field X1:Float
	Field Y1:Float
	Field X2:Float
	Field Y2:Float
	Field Friction:Float
	Field v1:verlet
	Field v2:verlet
	Field flipped:Int
	Field ID:Int
	
	Function Create:polyseg(x1#, y1#, x2#, y2#, Friction:Float = 0,ID:Int = 0)
		
		Local p:polyseg = New polyseg
		If x1 = x2 Then
			p.flipped = True
		Else
			If Abs((y1-y2)/(x1-x2)) > 1 Then p.flipped = True
		EndIf
		
		p.x1 = x1
		p.y1 = y1
		p.x2 = x2
		p.y2 = y2
		
		p.friction = friction
		p.index = polysegcount
		p.v1:verlet = verlet.Create(x1,y1,0,1,ID,0)
		p.v2:verlet = verlet.Create(x2,y2,0,1,ID,0)
		p.v1.ppolyseg = True
		p.v2.ppolyseg = True
		polysegarray:polyseg[polysegcount] = p:polyseg
		
		polysegcount = polysegcount + 1
		If polysegarray.length-polysegcount <= 2 Then
			Local tp:Int = polysegarray.length+100
			polysegarray = polysegarray[..tp]
		EndIf
		
		p.ID = ID
		
		Return p:polyseg

	End Function
	
	Method setfriction(f#)
		friction = f
	End Method
	
	Method reposition(xx1#,yy1#,xx2#,yy2#)
		x1 = xx1
		x2 = xx2
		y1 = yy1
		y2 = yy2
		v1.x = x1
		v1.y = y1
		v2.x = x2
		v2.y = y2
		v1.ox = x1
		v1.oy = y1
		v2.ox = x2
		v2.oy = y2
	End Method
	
	Method ChangeID(nid:Int)
		id = nid
		v1.id = nid
		v2.id = nid
	End Method
	
	Method remove()
		polysegcount = polysegcount - 1
		polysegarray:polyseg[index] = polysegarray:polyseg[polysegcount]
		polysegarray:polyseg[polysegcount] = Null
		Local ptmp:polyseg = polysegarray:polyseg[index]
		ptmp.index = index
	End Method
	
End Type




Function updatepolysegs(v:verlet)	'update polysegments by sweeping through each polysegment per verlet.  again.. forget commenting this heavily... I cant describe how it works
	Local tmpsizhx:Float = 0
	Local ide:Int = 0
	For Local pcnt:Int = 0 To polysegcount - 1
		Local p:polyseg = polysegarray[pcnt]
			If p.ID <> v.ID Then
				For Local ie:idexc = EachIn idexclist
					If p.ID = ie.id1 Or p.ID = ie.id2 Then
						If v.ID = ie.id1 Or v.ID = ie.id2 Then
							ide = True
						EndIf
					EndIf
				Next
				If ide = False Then
					If v.x > (Min(p.x1,p.x2)-maxverlsiz*2) And v.x < (Max(p.x1,p.x2)+maxverlsiz*2) And v.y > (Min(p.y1,p.y2)-maxverlsiz*2) And v.y < (Max(p.y1,p.y2)+maxverlsiz*2) Then
						Local tmpIntersectLineCircle#[][]
						Local acqrcoords#[]
						Local tmplinints:Int
						If p.flipped = False Then	'allows for accurate collision detection and fewer buggs.
							tmplinints = lines_intersect(v.x,v.y,v.ox,v.oy,p.x1,p.y1,p.x2,p.y2)
							If tmplinints Then
								tmpsizhx = 3000	'longer length = more accuracy
							Else
								tmpsizhx = v.siz
							EndIf
							
							tmpintersectlinecircle = linecircleintersect( [p.x1,p.y1] , [p.x2,p.y2] , [v.x,v.y] , tmpsizhx)
							
							If tmpIntersectLineCircle.length = 2 Then	
								Local i1x# = tmpintersectlinecircle[1][0]
								Local i1y# = tmpintersectlinecircle[1][1]
								Local i2x# = tmpintersectlinecircle[0][0]
								Local i2y# = tmpintersectlinecircle[0][1]
								
								Local imx# = (i1x + i2x) / 2
								Local imy# = (i1y + i2y) / 2
								
								If (imx# => p.x1 And imx# <= p.x2) Or (imx# <= p.x1 And imx# => p.x2) Then
									v.fricap = v.fricap - p.friction - v.friccr
									If tmplinints Then
										acqrcoords = acqrdistance2(imx# , imy# , v.x , v.y , v.siz)
									Else
										acqrcoords = acqrdistance(imx# , imy# , v.x , v.y , v.siz)
									EndIf
									v.x = acqrcoords[0]
									v.y = acqrcoords[1]
									v.collided = True
								EndIf
							EndIf
						Else
							tmplinints = lines_intersect(v.x,v.y,v.ox,v.oy,p.x1,p.y1,p.x2,p.y2)
							If tmplinints Then
								tmpsizhx = 3000	'longer length = more accuracy
							Else
								tmpsizhx = v.siz
							EndIf
	
							tmpintersectlinecircle = linecircleintersect( [p.y1,p.x1] , [p.y2,p.x2] , [v.y,v.x] , tmpsizhx)
							If tmpIntersectLineCircle.length = 2			
								Local i21x# = tmpintersectlinecircle[1][0]
								Local i21y# = tmpintersectlinecircle[1][1]
								Local i22x# = tmpintersectlinecircle[0][0]
								Local i22y# = tmpintersectlinecircle[0][1]
								
								Local i2mx# = (i21x + i22x) / 2
								Local i2my# = (i21y + i22y) / 2
								
								If (i2mx# => p.y1 And i2mx# <= p.y2) Or (i2mx# <= p.y1 And i2mx# => p.y2) Then
									v.fricap = v.fricap - p.friction - v.friccr
									If tmplinints Then
										acqrcoords = acqrdistance2(i2mx# , i2my# , v.y , v.x , v.siz)
									Else
										acqrcoords = acqrdistance(i2mx# , i2my# , v.y , v.x , v.siz)
									EndIf
									v.y = acqrcoords[0]
									v.x = acqrcoords[1]
									v.collided = True
								EndIf
							EndIf
						EndIf
					EndIf
				Else
					ide = False
				EndIf
			EndIf
	Next
	
End Function
