''''''''''''''''''''''''''''''''''''''''''''''''''''
'Rem									'
'Verlet Max								'
'By: Nate the Great (NTG)					'
'									'
'Description:							'
'Verlet Max is a verlet integration engine made For	'
'Blitz Max And written in Blitz Max.			'
'Superstrict Compatible!					'
'Date: April 18, 2009
'End Rem								'
									'
''''''''''''''''''''''''''''''''''''''''''''''''''''

Rem	Please Read this!
From the Author: Nathan Shirley

This is a free demonstration version of Verlet Max.
You may use it for commercial applications and games.
If you use this for commercial or non comercial purposes,
please give credit to me or put a link to my website in 11 point font or greater on a credits or readme for your game.
Also send me an email if you make any commercial product with Verlet Max because
I love to see what people can do with my products!  I might even put a link to your website
if I deem your game a great example of how this engine can be used.

Feel free to modify the source but please do not redistribute this software.
If you want to tell someone about Verlet max please refer them to my website where they can download it.

In its current state, Verlet Max Demo is very unorganized and messy, however it does contain all necessary features that may
be needed to make a game with realistic and fast physics.
In a few months, the full version MAY be released.  Until then, I might make temporary updates to this demo to make it more user friendly.

If you find a serious bug or have a question email me:

Email: nshirley@episcopalcollegiate.org
Website: http://naillproductions.synthasite.com/

EndRem

'''''''''''''''''''''''''''''''''''''''''''''''''''''
AutoMidHandle True
'used for line intersect functions

Global Intersection_X#
Global Intersection_Y#
Global Intersection_AB#
Global Intersection_CD#

''''''''''''''''''''''''''''''

Global verlcount:Int	'Number of Verlets ever made
Global constcount:Int	'Number of constraints ever made
Global polysegcount:Int	'number of polysegments ever made
Global Verletarray:Verlet[40000]	'you'll never need 4000 verlets because no average computer can handle more than that.. this is not a limit, its a dream ;)
Global Constraintarray:Constraint[40000]	'constraint array
Global imagelist:TList = New TList		'list of images attatched to verlet cages.  This must be a list for order issues
Global polysegarray:Polyseg[4000]		'array for polysegs which is short for polygon segments

Global physicsoffsetx:Float			'Offset x
Global physicsoffsety:Float			'offset y
Global physicsscalex:Float = 1			'scaling offset x
Global physicsscaley:Float = 1			'scaling offset y
Global physicsoriginx:Float = GraphicsWidth()/2
Global physicsoriginy:Float = GraphicsHeight()/2
Global VerletDamper:Float = 1	'the lower this number is, the more stable stacking will be but also the lower the precision will be.  It basically alows for 'soft' collisions between verlets

Global maxverlsiz:Int			'maximum verlet siz * 2
Global Friction:Float = 1		'Friction should be close to 1 unless you want very slow movement

Global Gravityx:Float = 0			'Gravity x		gravity vector
Global Gravityy:Float = .07			'Gravity y

Global ConstraintIterations:Int = 10	'constraint iterations
Global physicsUpperBound:Int = 0	'Upper physics bound
Global physicsLowerBound:Int = 0	'lower physics bound
Global physicsLeftBound:Int = 0	'left physics bound
Global physicsRightBound:Int = 0	'right physics bound

Global activerightbound:Int = 0	'if an object is outside of the acitve bounds, then it will not be updated!
Global activeleftbound:Int = 0
Global activeupbound:Int = 0
Global activelowbound:Int = 0


Function UpdatePhysics(cnt:Int = 1)	'
	For Local i:Int = 1 To cnt
		UpdateVerlets()
		UpdateConstraints()
		UpdateVerletPolysegCollisions()
	Next
End Function


Type Constraint
	
	Field index:Int
	Field v1:Verlet
	Field v2:Verlet
	Field Length:Float
	Field Elasticity:Float
	Field hidden:Int = False
	
	Function Create:Constraint(v1:Verlet, v2:Verlet, elasticity:Float = 1, Length:Float = -1)
		
		Local CC:Constraint = New Constraint
		CC.v1:Verlet = v1:Verlet
		CC.v2:Verlet = v2:verlet
		If length < 0 Then
			CC.Length = Sqr( (v1.x - v2.x)^2 + (v1.y - v2.y)^2 )	'Distance formula for the length
		Else
			CC.Length = Length
		EndIf
		CC.Elasticity = elasticity
		
		constraintarray:constraint[constcount] = CC:constraint
		CC.index = constcount
		Constcount = constcount + 1
		Return CC:Constraint
	End Function
	
	Method hide()
	
		hidden = True
	
	End Method
	
	Method show()
		
		hidden = False
	
	End Method
	
	Method remove()
		
		constcount = constcount - 1
		constraintarray:constraint[index] = constraintarray:constraint[constcount]
		Local ctmp:constraint = constraintarray:constraint[index]
		ctmp.index = index
		
	End Method
	
End Type


Function UpdateConstraints()	'constraint update function
	
	Local c:constraint
	Local totalmass#
	Local v1prop#
	Local v2prop#
	Local dx#
	Local dy#
	Local length#
	Local diff#
	Local mutip#
	
	For Local a:Int = 1 To ConstraintIterations
		For Local ccnt:Int = 0 To constcount - 1
			c:constraint = constraintarray:constraint[ccnt]
			totalmass# = c.v1.mass# + c.v2.mass#
			
			v1prop# = (c.v1.mass#/totalmass#) * 2
			v2prop# = (c.v2.mass#/totalmass#) * 2
			
			dx# = c.v1.x - c.v2.x
			dy# = c.v1.y - c.v2.y
			
			length# = Sqr(dx#*dx# + dy#*dy#)
			
			
			If length# <> 0 Then
				diff# = (length# - c.length) / length#
			Else
				diff# = 0
			EndIf
			
			dx# = dx# * .5
			dy# = dy# * .5
			
			If c.elasticity = 1 Then
				If a > ConstraintIterations - 4 Then	' take out this if statement and everything between the else and enif if you want to increase speed but lose stability
					If c.v1.active = True Then
						c.v1.x = c.v1.x - (diff# * dx#) * v2prop#
						c.v1.y = c.v1.y - (diff# * dy#) * v2prop#
					EndIf
					
					If c.v2.active = True Then
						c.v2.x = c.v2.x + (diff# * dx#) * v1prop#
						c.v2.y = c.v2.y + (diff# * dy#) * v1prop#
					EndIf
				Else
					If c.v1.active = True Then
						c.v1.x = c.v1.x - ((diff# * dx#) * v2prop#)/20
						c.v1.y = c.v1.y - ((diff# * dy#) * v2prop#)/20
					EndIf
					
					If c.v2.active = True Then
						c.v2.x = c.v2.x + ((diff# * dx#) * v1prop#)/20
						c.v2.y = c.v2.y + ((diff# * dy#) * v1prop#)/20
					EndIf
				EndIf
			Else
				mutip# = c.elasticity'*constraintiterations
				If c.v1.active = True Then
					c.v1.x = c.v1.x - ((diff# * dx#) * v2prop#)/mutip
					c.v1.y = c.v1.y - ((diff# * dy#) * v2prop#)/mutip
				EndIf
				If c.v2.active = True Then
					c.v2.x = c.v2.x + ((diff# * dx#) * v1prop#)/mutip
					c.v2.y = c.v2.y + ((diff# * dy#) * v1prop#)/mutip
				EndIf
			EndIf
			c.v1.collided = False
			c.v2.collided = False
			
		Next
	Next

End Function



Type Verlet				'Verlet Type
	
	Field index:Int
	Field X#
	Field Y#
	Field OX#
	Field OY#
	Field VX#
	Field VY#
	Field Siz:Float
	Field Collided:Int
	Field ID:Int = 0
	Field mass:Float
	Field active:Int = True
	Field fricap:Float
	Field friccr:Float
	Field done:Int
	Field hidden:Int
	Field ghost:Int
	'images stuff
	Field image:TImage
	Field angle:Float = 0
	Field alph:Float = 1
	Field sclx:Float = 1
	Field scly:Float = 1
	Field r:Int = 255
	Field g:Int = 255
	Field b:Int = 255
	Field blendmode:Int = alphablend
	
	
	
	Function Create:Verlet(x#,y#,siz:Float,mass:Float,ID:Int,active:Int = True,ox# = 0,oy# = 0,friction# = 0)
		Local  VV:Verlet = New Verlet
		VV.x# = x#			'verlet x
		VV.y# = y#			'verlet y
		VV.ox# = x# + ox#		'verlet old x
		VV.oy# = y# + oy#		'verlet old y
		VV.siz = siz			'verlet radius
		VV.Collided = False		'collision variable
		VV.ID = ID			'Verlet ID
		VV.mass = mass			'Verlet mass
		VV.vx# = 0			'Verlet velocity x
		VV.vy# = 0			'Verlet velocity y
		VV.active = active
		VV.friccr = friction
		VV.done = False
		VV.fricap = 1
		VV.hidden = True		'inverted
		Verletarray:Verlet[verlcount] = VV:Verlet
		VV.index = verlcount
		verlcount = verlcount + 1
		If siz*2 > maxverlsiz Then
			maxverlsiz = siz*2 + 1
		EndIf
		
		Return VV:Verlet
	End Function
	
	Method hide()
	
		hidden = False
	
	End Method
	
	Method show()
	
		hidden = True
	
	End Method
	
	Method setfriction(f#)
		friccr = f#
	End Method
	
	Method setmass(m#)
		mass = m
	End Method
	
	Method activate()
		active = True
	End Method
	
	Method deactivate()
		active = False
	End Method
	
	Method setghost()
		ghost = True
	End Method
	
	Method unghost()
		ghost = False
	End Method
	
	Method setradius(r#)
		siz = r
	End Method
	
	Method setvelocity(xx#,yy#)
		ox = x - xx
		oy = y - yy
	End Method
	
	Method addvelocity(xx#,yy#)
		ox = ox - xx#
		oy = oy - yy#
	End Method
	
	Method attachimage(i:TImage)
		image = i
	End Method	
	
	Method rotate(r#)
		angle :+ r#
	End Method
	
	Method setangle(r#)
		angle = r#
	End Method
	
	Method blend(b:Int)
		blendmode = b
	End Method
	
	Method color(rr:Int,gg:Int,bb:Int)
		r = rr
		g = gg
		b = bb
	End Method
	
	Method scale(xs:Float,ys:Float)
		sclx = xs
		scly = ys
	End Method
	
	Method alpha(a#)
		alph = a
	End Method
	
	Method remove()
		
		verlcount = verlcount - 1
		verletarray:verlet[index] = verletarray:verlet[constcount]
		Local vtmp:verlet = verletarray:verlet[index]
		vtmp.index = index
		
	End Method
	
End Type





Function checkverletbounds(v:verlet)
	
	If v.x+v.siz > physicsrightbound Then
		v.ox = v.x
		v.x = physicsrightbound-v.siz
	ElseIf v.x-v.siz < physicsleftbound Then
		v.ox = v.x
		v.x = physicsleftbound+v.siz
	EndIf
	If v.y+v.siz > physicslowerbound Then
		v.oy = v.y
		v.y = physicslowerbound-v.siz
	ElseIf v.y-v.siz < physicsupperbound
		v.oy = v.y
		v.y = physicsupperbound+v.siz
	EndIf
	
End Function






Function UpdateVerlets()
	
	Local v:verlet
	Local vcnt:Int
	Local wfric:Int
	Local tmpox1:Float
	Local tmpoy1:Float
	Local vcnt2:Int
	Local vv:verlet
	Local dx#
	Local dy#
	Local dist#
	Local totalr#
	Local totmass#
	Local v1ofs:Float
	Local v2ofs:Float
	Local dmtr:Float
	Local diffx:Float
	Local diffy:Float
	
	For vcnt:Int = 0 To verlcount-1
		V:verlet = Verletarray:Verlet[vcnt]
		If V.active = True Then
			
			
			checkverletbounds v:verlet
			
			If v.x < activerightbound And v.x > activeleftbound And v.y > activeupbound And v.y < activelowbound Then
				
				V.done = True	'prevents checking against self
				
				
				V.collided = False		'Resets collision variable
				
				
				v.vx = (v.x - v.ox) * (Friction) 'Gets velocities of verlets
				v.vy = (v.y - v.oy) * (Friction)
				
				
				v.vx:*v.fricap
				v.vy:*v.fricap
				V.fricap = 1
				
				
				
				v.vx = v.vx + Gravityx	'Keeps track of X velocity
				v.vy = v.vy + Gravityy	'Applies Gravity
				
				
				v.ox = v.x
				v.oy = v.y
			
				v.x = v.x + (v.vx)
				v.y = v.y + (v.vy)
				
						
				
				If Not v.ghost Then
					For vcnt2:Int = 0 To verlcount-1
						VV:verlet = Verletarray:Verlet[vcnt2]
						If vv.done = False And vv.ghost = False Then
							dx# = v.x - vv.x
							dy# = v.y - vv.y
							If Abs(dx) < maxverlsiz And Abs(dy) < maxverlsiz Then
								If v.id <> vv.id   ' If Not the same verlet Or group
									
									dist# = Sqr( dx#*dx# + dy#*dy#)		
									totalr# = v.siz# + vv.siz#
									If dist# < totalr# And dist > 0 Then
										v.fricap = v.fricap - vv.friccr
										vv.fricap = vv.fricap - v.friccr
										
										totmass# = v.mass + vv.mass
										v1ofs# = (v.mass/totmass) * 2
										v2ofs# = (vv.mass/totmass) * 2
										
										dmtr# = dist#-totalr#							
										Diffx# = ( dmtr# ) * ( dx# / dist# )
										Diffy# = ( dmtr# ) * ( dy# / dist# )
										If v.active = True Then
											v.x = v.x - Diffx# *v2ofs* VerletDamper
											v.y = v.y - Diffy# *v2ofs* VerletDamper
										EndIf
										
										If vv.active = True Then
											vv.x = vv.x + Diffx# *v1ofs* .3
											vv.y = vv.y + Diffy# *v1ofs* .3
										EndIf
										
									EndIf
								EndIf
							EndIf
						EndIf
					Next
				EndIf
				
				
			EndIf
		EndIf
	Next
	
	Local vtmp:verlet
	For Local v2cnt:Int = 0 To verlcount - 1
		vtmp:verlet = verletarray:verlet[v2cnt]
		vtmp.done = False
	Next
End Function






Type PhysicsImage
	Field c:Constraint
	Field rotationoffset:Float
	Field image:TImage
	Field alph#
	Field r:Int,g:Int,b:Int
	Field sclx#,scly#
	Field blendmode:Int
	
	Function Create:PhysicsImage(con:constraint,image:TImage,r:Int = 255,g:Int = 255,b:Int = 255,alph# = 1,sclx# = 1,scly# = 1,blend:Int = alphablend,setflg:Int = True)
		
		Local P:PhysicsImage = New PhysicsImage
		P.c:constraint = con:constraint
		P.image = image
		If setflg = True Then
			p.rotationoffset = ATan2(con.v1.x-con.v2.x,con.v1.y-con.v2.y)
		Else
			p.rotationoffset = 0
		EndIf
		
		P.r = r
		p.g = g
		p.b = b
		p.alph# = alph#
		p.sclx = sclx
		p.scly = scly
		p.blendmode = blend
		
		Imagelist.addlast(P:physicsimage)
		
		Return P:physicsimage
		
	End Function
	
	Method rotate(angle:Int)
		rotationoffset :+ angle
	End Method
	
	Method scale(sx#,sy#)
		sclx# = sx#
		scly# = sy#
	End Method
	
	Method alpha(a#)
		alph# = a#
	End Method
	
	Method blend(b:Int)
		blendmode = b
	End Method
	
	Method color(r1:Int,g1:Int,b1:Int)
		r = r1
		g = g1
		b = b1
	End Method
	
	Method remove()
		imagelist.remove(Self)
	End Method
	
End Type



Function updatephysicsimage()	'updates physics images

	Local temprotof:Float
	For Local p:physicsimage = EachIn imagelist
		SetColor p.r,p.g,p.b
		SetAlpha p.alph
		SetBlend p.blendmode
		SetScale p.sclx,p.scly
		temprotof = -(ATan2(p.c.v1.x-p.c.v2.x,p.c.v1.y-p.c.v2.y)-p.rotationoffset)
		SetRotation temprotof
		DrawImage p.image,(p.c.v1.x+p.c.v2.x)/2+physicsoffsetx,(p.c.v1.y+p.c.v2.y)/2+physicsoffsety
	Next
	SetRotation 0
	SetScale 1,1
	SetColor 255,255,255
	SetAlpha 1
	SetBlend alphablend
	
EndFunction





Type Polyseg	'polygon segment
	Field index:Int
	Field X1:Float
	Field Y1:Float
	Field X2:Float
	Field Y2:Float
	Field Friction:Float
	Field v1:verlet
	Field v2:verlet
	Field flipped:Int
	
	Function Create:polyseg(x1#, y1#, x2#, y2#, Friction:Float = 0)
		
		Local p:polyseg = New polyseg
	
		If Abs((y1-y2)/(x1-x2)) > 1 Then p.flipped = True
		
		p.x1 = x1
		p.y1 = y1
		p.x2 = x2
		p.y2 = y2
		
		p.friction = friction
		p.index = polysegcount
		p.v1:verlet = verlet.Create(x1,y1,0,1,0,0)
		p.v2:verlet = verlet.Create(x2,y2,0,1,0,0)
		
		polysegarray:polyseg[polysegcount] = p:polyseg
		
		polysegcount = polysegcount + 1
		Return p:polyseg

	End Function
	
	Method setfriction(f#)
		friction = f
	End Method
	
	Method reposition(xx1#,yy1#,xx2#,yy2#)
		x1 = xx1
		x2 = xx2
		y1 = yy1
		y2 = yy2
		v1.x = x1
		v1.y = y1
		v2.x = x2
		v2.y = y2
	End Method
	
	Method remove()
		polysegcount = polysegcount - 1
		polysegarray:polyseg[index] = polysegarray:polyseg[polysegcount]
		Local ptmp:polyseg = polysegarray:polyseg[index]
		ptmp.index = index
	End Method
	
End Type




Function updatepolysegs(v:verlet)	'update polysegments by sweeping through each polysegment per verlet.  again.. forget commenting this heavily... I cant describe how it works
	Local tmpsizhx:Float = 0
	For Local pcnt:Int = 0 To polysegcount - 1
		Local p:polyseg = polysegarray[pcnt]
			If v.x > (Min(p.x1,p.x2)-maxverlsiz*2) And v.x < (Max(p.x1,p.x2)+maxverlsiz*2) And v.y > (Min(p.y1,p.y2)-maxverlsiz*2) And v.y < (Max(p.y1,p.y2)+maxverlsiz*2) Then
				Local tmpIntersectLineCircle#[][]
				Local acqrcoords#[]
				Local tmplinints:Int
				If p.flipped = False Then	'allows for accurate collision detection and fewer buggs.
					tmplinints = lines_intersect(v.x,v.y,v.ox,v.oy,p.x1,p.y1,p.x2,p.y2)
					If tmplinints Then
						tmpsizhx = 3000	'longer length = more accuracy
					Else
						tmpsizhx = v.siz
					EndIf
					
					tmpintersectlinecircle = linecircleintersect( [p.x1,p.y1] , [p.x2,p.y2] , [v.x,v.y] , tmpsizhx)
					
					If tmpIntersectLineCircle.length = 2 Then	
						Local i1x# = tmpintersectlinecircle[1][0]
						Local i1y# = tmpintersectlinecircle[1][1]
						Local i2x# = tmpintersectlinecircle[0][0]
						Local i2y# = tmpintersectlinecircle[0][1]
						
						Local imx# = (i1x + i2x) / 2
						Local imy# = (i1y + i2y) / 2
						
						If (imx# => p.x1 And imx# <= p.x2) Or (imx# <= p.x1 And imx# => p.x2) Then
							v.fricap = v.fricap - p.friction - v.friccr
							If tmplinints Then
								acqrcoords = acqrdistance2(imx# , imy# , v.x , v.y , v.siz)
							Else
								acqrcoords = acqrdistance(imx# , imy# , v.x , v.y , v.siz)
							EndIf
							v.x = acqrcoords[0]
							v.y = acqrcoords[1]
							v.collided = True
						EndIf
					EndIf
				Else
					tmplinints = lines_intersect(v.x,v.y,v.ox,v.oy,p.x1,p.y1,p.x2,p.y2)
					If tmplinints Then
						tmpsizhx = 3000
					Else
						tmpsizhx = v.siz
					EndIf
					
					tmpintersectlinecircle = linecircleintersect( [p.y1,p.x1] , [p.y2,p.x2] , [v.y,v.x] , v.siz)
					
					If tmpIntersectLineCircle.length = 2			
						Local i21x# = tmpintersectlinecircle[1][0]
						Local i21y# = tmpintersectlinecircle[1][1]
						Local i22x# = tmpintersectlinecircle[0][0]
						Local i22y# = tmpintersectlinecircle[0][1]
						
						Local i2mx# = (i21x + i22x) / 2
						Local i2my# = (i21y + i22y) / 2
						
						If (i2mx# => p.y1 And i2mx# <= p.y2) Or (i2mx# <= p.y1 And i2mx# => p.y2) Then
							v.fricap = v.fricap - p.friction - v.friccr
							If tmplinints Then
								acqrcoords = acqrdistance2(i2mx# , i2my# , v.y , v.x , v.siz)
							Else
								acqrcoords = acqrdistance(i2mx# , i2my# , v.y , v.x , v.siz)
							EndIf
							v.y = acqrcoords[0]
							v.x = acqrcoords[1]
							v.collided = True
						EndIf
					EndIf
				EndIf
			EndIf
	Next
	
End Function



Function acqrdistance#[](x:Float,y:Float,x2:Float,y2:Float,acqdist:Float)	'x = col point x2 = center of collided circle ditto for y's  acqdist = the distance to acquire between these two points
	
	Local temparay#[]
	Local nx:Float
	Local ny:Float
	Local dx! = x - x2	'doubles because these are the cause of most floating point inacuracy that causes jerking and bouncing around
	Local dy!= y - y2
	Local dist:Float = Sqr(dx*dx + dy*dy)
	
	If dist < acqdist And dist > 0 Then
		
		dx = (dx / dist) * acqdist
		dy = (dy / dist) * acqdist
		nx = x - dx
		ny = y - dy
		
	Else
		nx = x2
		ny = y2
	EndIf
	
	temparay# = [nx,ny]
	
	Return temparay#
	
End Function



Function acqrdistance2#[](x:Float,y:Float,x2:Float,y2:Float,acqdist:Float)	'x = col point x2 = center of collided circle ditto for y's  acqdist = the distance to acquire between these two points
	
	Local temparay#[]
	Local nx:Float
	Local ny:Float
	Local dx! = x - x2	'doubles because these are the cause of most floating point inacuracy that causes jerking and bouncing around
	Local dy!= y - y2
	Local dist:Float = Sqr(dx*dx + dy*dy)
	
	If dist > 0 Then	'took out dist < acqdist
		
		dx = (dx / dist) * acqdist
		dy = (dy / dist) * acqdist
		nx = x + dx
		ny = y + dy
		
	Else
		nx = x2
		ny = y2
	EndIf
	
	temparay# = [nx,ny]
	
	Return temparay#
	
End Function




Function linecircleintersect#[][]( pLineStart#[], pLineEnd#[], pCircleCenter#[], pCircleRadius# )	'many thanks to blitz support for this one!
	
	Local tmpIntersections#[][]
	
	Local p# = pCircleCenter[0], q# = pCircleCenter[1]
	Local m# = (pLineEnd[1]-pLineStart[1])/(pLineEnd[0]-pLineStart[0])
	Local r# = pCircleRadius
	Local t# = pLineEnd[1]- (m*pLineEnd[0])
	Local s# = t-q
	
	Local a# = m*m + 1, b# = (2*m*s) - (2*p), c# = s*s + p*p - (r*r)
	
	Local bsqminfourac# = b*b-4*a*c
	
	If bsqminfourac > 0 Then
		
		bsqminfourac = Sqr(bsqminfourac)
		
		Local x1# = ((-b)+bsqminfourac)/(2*a)
		Local x2# = ((-b)-bsqminfourac)/(2*a)
		
		tmpIntersections = [[x1,(m*x1)+t],[x2,(m*x2)+t]]
		
	ElseIf bsqminfourac = 0 Then
		
		tmpIntersections = [[(-b)/(2*a),(-b*m)/(2*a)+t]]
		
	EndIf
	
	Return tmpIntersections

EndFunction

Function Drawall()	'draws everything set to "visible"
	
	DrawConstraints()
	DrawVerlets()
	DrawPolysegs()
	UpdatePhysicsImage()
	
End Function

Function DrawPolysegs()	'draws polygon segments
	
	SetAlpha 1
	SetColor 255,255,255
	SetBlend alphablend
	SetScale 1,1
	SetRotation 0
	
	For Local pcnt:Int = 0 To polysegcount - 1
		Local p:polyseg = polysegarray[pcnt]
		DrawLinescl (p.x1+physicsoffsetx),(p.y1+physicsoffsety),(p.x2+physicsoffsetx),(p.y2+physicsoffsety)
	Next
	
End Function

Function DrawVerlets()	'draws the verlets
	For Local vcnt:Int = 0 To verlcount-1
		Local v:verlet = verletarray:verlet[vcnt]
		If v.hidden Then
			SetAlpha v.alph
			SetBlend v.blendmode
			SetRotation v.angle
			SetScale v.sclx*physicsscalex,v.scly*physicsscaley
			SetColor v.r,v.g,v.b
			If v.image Then
				DrawImage(v.image,((v.x+physicsoffsetx-physicsoriginx)*physicsscalex)+physicsoriginx,((v.y+physicsoffsety-physicsoriginy)*physicsscaley)+physicsoriginy)
			Else
				SetScale 1,1
				DrawCircle( ((v.x+physicsoffsetx-physicsoriginx)*physicsscalex)+physicsoriginx, ((v.y+physicsoffsety-physicsoriginy)*physicsscaley)+physicsoriginy, v.siz*physicsscalex, v.siz*physicsscaley)
			EndIf
		EndIf
	Next
	SetScale 1,1
	SetAlpha 1
	SetBlend alphablend
	SetRotation 0
	SetColor 255,255,255
End Function

Function drawcircle(x:Int,y:Int,radiusx:Int,radiusy:Int)	'draws a circle

DrawOval x-radiusx,y-radiusy,radiusx*2,radiusy*2

End Function

Function DrawConstraints()	'draws constraints
	
	SetAlpha 1
	SetColor 255,255,255
	SetBlend alphablend
	SetScale 1,1
	SetRotation 0
	
	For Local ccnt:Int = 0 To constcount - 1
		Local c:constraint = constraintarray:constraint[ccnt]
		If Not c.hidden Then
			DrawLinescl c.v1.x+physicsoffsetx,c.v1.y+physicsoffsety,c.v2.x+physicsoffsetx,c.v2.y+physicsoffsety
		EndIf
	Next
	
End Function


Function drawlinescl(x1:Int,y1:Int,x2:Int,y2:Int)	'draws a scaled line

DrawLine ((x1-physicsoriginx)*physicsscalex)+physicsoriginx,((y1-physicsoriginy)*physicsscaley)+physicsoriginy,((x2-physicsoriginx)*physicsscalex)+physicsoriginx,((y2-physicsoriginy)*physicsscaley)+physicsoriginy

End Function


Function Lines_Intersect:Int(Ax#, Ay#, Bx#, By#, Cx#, Cy#, Dx#, Dy#)	'finds the line intersections... never mind commenting the math.. I dont even understand it anymore
	Local Rn# = (Ay#-Cy#)*(Dx#-Cx#) - (Ax#-Cx#)*(Dy#-Cy#)
	Local Rd# = (Bx#-Ax#)*(Dy#-Cy#) - (By#-Ay#)*(Dx#-Cx#)
		
	If Rd# = 0 
		
		' Lines are parralel.
		' If Rn# is also 0 Then lines are coincident.  All points intersect. 
		' Otherwise, there is no intersection point.
		Return False
	Else
		' The lines intersect at some point.  Calculate the intersection point.
	Local Sn# = (Ay#-Cy#)*(Bx#-Ax#) - (Ax#-Cx#)*(By#-Ay#)
		Intersection_AB# = Rn# / Rd#
		Intersection_CD# = Sn# / Rd#
		Intersection_X# = Ax# + Intersection_AB#*(Bx#-Ax#)
		Intersection_Y# = Ay# + Intersection_AB#*(By#-Ay#)	
	EndIf
		
	If Intersection_AB#>0 And Intersection_AB#<1 And Intersection_CD#>0 And Intersection_cd#<1
			Return True	
		Else
			Return False
	EndIf


End Function


Function UpdateVerletPolysegCollisions()

Local cnt:Int = 0
Local v:verlet

For cnt = 0 To Verlcount
	V:verlet = Verletarray:Verlet[cnt]
	If V.active = True Then
		
		
		checkverletbounds v:verlet
		
		If v.x < activerightbound And v.x > activeleftbound And v.y > activeupbound And v.y < activelowbound Then
			
			If v.ghost = False Then updatepolysegs(v:verlet)
		
		EndIf
		
	EndIf
	
Next

End Function