Global verlcount:Int	'Number of Verlets ever made
Global Verletarray:Verlet[100]	'	verlet array

Type Verlet				'Verlet Type
	
	Field deleted:Int
	Field index:Int	'position in the verlet array
	
	Field name$		'name of the verlet
		
	Field ncnt:Int
	
	Field NX#	'used to accumulate forces
	Field NY#
	
	Field X#	' x,y coordinates
	Field Y#
	
	Field OX#	'oldx,oldy coords
	Field OY#
	
	Field VX#	'velocity from previous frame
	Field VY#
	
	Field Siz:Float	'radius
	
	Field Collided:Int	'internal
	
	Field ID:Int = 0	'id
	
	Field mass:Float	'mass of verlet
	
	Field active:Int = True	'active means the verlet can move about
	
	Field fricap:Float	'friction the verlet has applied to it.  (internal)
	Field friccr:Float	'friction the verlet creates
	
	Field fricacx:Float	'friction accumulation x
	Field fricacy:Float	'friction accumulation y
	
	Field done:Int	'internal
	Field hidden:Int	'is the verlet drawn?
	Field ghost:Int	'makes a verlet that doesnt collide with anything
	'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
	'images stuff
	
	Field image:TImage	'image
	
	Field angle:Float = 0	'angle it is rotated to when drawn
	Field alph:Float = 1	'alpha
	Field sclx:Float = 1	'scale x
	Field scly:Float = 1	'scale y
	
	Field r:Int = 255	'red green and blue
	Field g:Int = 255
	Field b:Int = 255
	Field blendmode:Int = alphablend
	
	'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
	'fluids stuff
	
	Field fluid:Int		'true if verlet is part of a fluid
	
	Field flrad:Float		'fluid radius at which the engine will form/break a constraint
	Field fllen:Float		'length of constraint formed
	Field flflex:Float	'flexibility of constraint formed outside of the length
	Field flflexi:Float	'flexibility of constraint formed inside of the length
	Field flid:Int		'id for fluid engine
	
	Field ppolyseg:Int
	'miscelaneous
	Field GD:grid	'grid cell
	
	Method replaceproperties(v:verlet)
		siz = v.siz
		id = v.id
		mass = v.mass
		active = v.active
		fricap = v.fricap
		friccr = v.friccr
		hidden = v.hidden
		ghost = v.ghost
		image = v.image
		angle = v.angle
		alph = v.alph
		sclx = v.sclx
		scly = v.scly
		r = v.r
		g = v.g
		b = v.b
		blendmode = v.blendmode
		fluid = v.fluid
		flrad = v.flrad
		fllen = v.fllen
		flflex = v.flflex
		flflexi = v.flflexi
		flid = v.flid
	End Method
	
	Function Create:Verlet(x#,y#,siz:Float,mass:Float,ID:Int,active:Int = True,ox# = 0,oy# = 0,friction# = 0,fluid:Int = False,flrad:Float = 0,fllen:Float = 0,flflex:Float = 0,flflexi:Float = 0,flid:Int = 0)
		Local  VV:Verlet = New Verlet
		VV.nx = x
		VV.ny = y
		VV.x# = x#			'verlet x
		VV.y# = y#			'verlet y
		VV.ox# = x# + ox#		'verlet old x
		VV.oy# = y# + oy#		'verlet old y
		VV.siz = siz			'verlet radius
		VV.Collided = False		'collision variable
		VV.ID = ID			'Verlet ID
		VV.mass = mass			'Verlet mass
		VV.vx# = 0			'Verlet velocity x
		VV.vy# = 0			'Verlet velocity y
		VV.active = active
		VV.friccr = friction
		VV.done = False
		VV.fricap = 1
		VV.hidden = True		'inverted
		VV.fluid = fluid
		VV.flrad = flrad
		VV.fllen = fllen
		VV.flflex = flflex
		VV.flflexi = flflexi
		VV.flid = flid
		
		If flrad*2 + 2 > maxverlsiz Then maxverlsiz = flrad*2+2
		
		Verletarray:Verlet[verlcount] = VV:Verlet
		VV.index = verlcount
		verlcount = verlcount + 1
		If verletarray.length-verlcount =< 2 Then verletarray = verletarray[..(verletarray.length+300)]
		If siz*2 + 2 > maxverlsiz Then
			maxverlsiz = siz*2 + 2
		EndIf
		
		Return VV:Verlet
	End Function
	
	Method setfluidproperties(fld:Int,rad:Float,Length:Float,flex:Float,flexi:Float,id:Int = 0)
		fluid = fld
		flrad = rad
		fllen = length
		flflex = flex
		flid = id
		flflexi = flexi
		If rad*2 + 2 > maxverlsiz Then maxverlsiz = rad*2+2
	End Method
	
	Method setposition(xx:Int,yy:Int)	'this positions the verlet to the x,y coordinates you give it while preserving its velocity
		Local xmx:Float = xx-x
		Local ymy:Float = yy-y
		x = xx
		ox = ox + xmx
		y = yy
		oy = oy + ymy
	End Method
	
	Method move(xx:Int,yy:Int) 	'this moves the verlet by the given x and y values but does not preserve the velocity
		x = x + xx
		y = y + yy
	End Method
	
	Method hide()
	
		hidden = False
	
	End Method
	
	Method show()
	
		hidden = True
	
	End Method
	
	Method setfriction(f#)
		friccr = f#
	End Method
	
	Method setmass(m#)
		mass = m
	End Method
	
	Method activate()
		active = True
	End Method
	
	Method deactivate()
		active = False
	End Method
	
	Method setghost()
		ghost = True
	End Method
	
	Method unghost()
		ghost = False
	End Method
	
	Method setradius(r#)
		siz = r
	End Method
	
	Method setvelocity(xx#,yy#)
		ox = x - xx
		oy = y - yy
	End Method
	
	Method addvelocity(xx#,yy#)
		ox = ox - xx#
		oy = oy - yy#
	End Method
	
	Method attachimage(i:TImage)
		image = i
	End Method	
	
	Method rotate(r#)
		angle :+ r#
	End Method
	
	Method setangle(r#)
		angle = r#
	End Method
	
	Method blend(b:Int)
		blendmode = b
	End Method
	
	Method color(rr:Int,gg:Int,bb:Int)
		r = rr
		g = gg
		b = bb
	End Method
	
	Method scale(xs:Float,ys:Float)
		sclx = xs
		scly = ys
	End Method
	
	Method alpha(a#)
		alph = a
	End Method
	
	Method remove()
		
		verlcount = verlcount - 1
		verletarray:verlet[index] = verletarray:verlet[verlcount]
		Local vtmp:verlet = verletarray:verlet[index]
		vtmp.index = index
		deleted = True
	End Method
	
	Method updt()
		ncnt = 0
		
		vx = (x - ox) * (Friction) 'Gets velocities of verlets
		vy = (y - oy) * (Friction)
		
		
		vx:*fricap
		vy:*fricap
		fricap = 1
				
		vx = vx + Gravityx	'Keeps track of X velocity
		vy = vy + Gravityy	'Applies Gravity
		
		
		ox = x
		oy = y
	
		x = x + (vx)
		y = y + (vy)
		
		nx = 0
		ny = 0
	End Method
	
	Function Update()
		
		Local v:verlet
		Local vcnt:Int
		Local tmpox1:Float
		Local tmpoy1:Float
		Local vcnt2:Int
		Local vv:verlet
		Local dx#
		Local dy#
		Local dist#
		Local totalr#
		Local totmass#
		Local v1ofs:Float
		Local v2ofs:Float
		Local dmtr:Float
		Local diffx:Float
		Local diffy:Float
		
		
		Local tmp1:Float
		For vcnt = 0 To verlcount-1
			v:verlet = verletarray:verlet[vcnt]
			If v.active Then v.updt
			tmp1 = (Int(v.siz) Shl 1) + 2
			If tmp1 > maxverlsiz Then maxverlsiz = tmp1
		Next
		
		
		If gridactive Then
			grid.update
		Else
			For vcnt:Int = 0 To verlcount-1
				V:verlet = Verletarray:Verlet[vcnt]
				If V.active = True Then
					
					
					v.checkverletbounds
															
						V.done = True	'prevents checking against self
						
						
						V.collided = False		'Resets collision variable
									
						If Not v.ghost Then
							For vcnt2:Int = 0 To verlcount-1
								VV:verlet = Verletarray:Verlet[vcnt2]
								DoVCollisions(v:verlet,vv:verlet)	'do collisions between the two verlets
							Next
						EndIf
				EndIf
			Next
		EndIf
		
		Local vtmp:verlet
		For Local v2cnt:Int = 0 To verlcount - 1
			vtmp:verlet = verletarray:verlet[v2cnt]
			vtmp.done = False
			If vtmp.active Then
				vtmp.x:+ vtmp.nx
				vtmp.y:+ vtmp.ny
			EndIf
		Next
		
	End Function
	
	

	Method checkverletbounds()
		
		If x+siz > physicsrightbound Then
			 ox =  x
			 x = physicsrightbound- siz
		ElseIf  x- siz < physicsleftbound Then
			 ox =  x
			 x = physicsleftbound+ siz
		EndIf
		If  y+ siz > physicslowerbound Then
			 oy =  y
			 y = physicslowerbound- siz
		ElseIf  y- siz < physicsupperbound
			 oy =  y
			 y = physicsupperbound+ siz
		EndIf
		
	End Method


End Type









Function DoVCollisions(v:verlet,vv:verlet)
	
	
	
	
		If vv.done = False And vv.ghost = False Then
			
			Local dx#
			Local dy#
			
			dx# = v.x - vv.x
			dy# = v.y - vv.y
			If dx = 0 And dy = 0 Then
				dx:+1
				v.x:+1
			EndIf
			If Abs(dx) < maxverlsiz And Abs(dy) < maxverlsiz Then
				
				
				Local ida:Int
				Local ia:IDALL
				Local idpassflag:Int
			
				ida = False
				idpassflag = False
				If v.id = vv.id  ' If Not the same verlet Or group
					idpassflag = True
					For ia:IDALL = EachIn IDALLlist
						If ia.id = v.id Then ida = True
					Next
				EndIf
				If ida = True Or idpassflag = False
					
					Local ide:Int
					Local ie:IDexc
					
					For ie:IDexc = EachIn IDexclist
						If v.id = ie.id1 Or v.id = ie.id2 Then
							If vv.id = ie.id1 Or vv.id = ie.id2 Then
								ide = True
							EndIf
						EndIf
					Next
					If ide = False Then
						
						
						
						Local dist#
						Local totalr#
						
						
						dist# = Sqr( dx#*dx# + dy#*dy#)		
						totalr# = v.siz# + vv.siz#
						
						Local len2:Float	'len2 is the actual length
						Local len1:Float	'they try to be len1 appart
						Local ddiff:Float	'the difference between the dist they are and where they want to be
						Local vms:Float	'percentage that v's mass makes of the total mass
						Local vvms:Float	'percentage that vv's mass makes of the total mass
						Local tms:Float = v.mass + vv.mass	'this is the total mass
						Local vfluid:Int
						Local vvfluid:Int
						
						Local trr:Float	'total radius
						
						If v.ppolyseg Or vv.ppolyseg Then
							vfluid = False
							vvfluid = False
						Else
							vfluid = v.fluid
							vvfluid = vv.fluid
						EndIf
						Local ff:flproperty
						For Local f:flproperty = EachIn flplist
							If (f.flid1 = v.flid And f.flid2 = vv.flid) Or (f.flid1 = vv.flid And f.flid2 = v.flid)
								ff:flproperty = f:flproperty
							EndIf
						Next
						
						
						For Local flr:flreaction = EachIn flrlist
							If flr.v1id = v.flid And flr.v2id = vv.flid Then
								flreaction.react(v:verlet,vv:verlet,flr:flreaction)
							ElseIf flr.v1id = vv.flid And flr.v2id = v.flid Then
								flreaction.react(vv:verlet,v:verlet,flr:flreaction)
							EndIf
						Next
						
						If vfluid And dist > 0 Then
							
							If vvfluid Then
								If ff:flproperty = Null Then
									trr = v.flrad+vv.flrad
									If dist <= trr Then
										flconstraint.Create(v:verlet,vv:verlet,vv.fllen+v.fllen,(v.flflex+vv.flflex)/2,(vv.flflexi+v.flflexi)/2,1)
									EndIf
								Else
									trr = ff.frad
									If dist <= trr Then
										flconstraint.Create(v:verlet,vv:verlet,ff.flen,ff.fflex,ff.fflexi,1)
									EndIf
								EndIf
								
								Rem
								'both are fluids
								len2 = vv.flrad + v.flrad
								
								If dist# < (len2) Then
									len1 = vv.fllen + v.fllen
									dx = dx / dist
									dy = dy / dist
									ddiff = len1-dist
									dx:* ddiff
									dy:* ddiff
									vvms = v.mass/tms
									vms = vv.mass/tms
									Local fl:Float = (v.flflex + vv.flflex)/2
									dx = dx * fl
									dy = dy * fl
									v.nx:+dx*vms
									v.ny:+dy*vms
									vv.nx:-dx*vvms
									vv.ny:-dy*vvms
								EndIf
								EndRem
							Else
								trr = vv.siz+v.flrad
								If dist <= trr Then
									flconstraint.Create(v:verlet,vv:verlet,vv.siz+v.fllen,v.flflex,v.flflexi,2)
								EndIf
								Rem
								'only the v is a fluid
								len2 = v.flrad + vv.siz
								
								If dist# < (len2) Then
									len1 = v.fllen + vv.siz
									dx = dx / dist
									dy = dy / dist
									ddiff = len1-dist
									dx:* ddiff
									dy:* ddiff
									vvms = v.mass/tms
									vms = vv.mass/tms
									dx = dx * v.flflex
									dy = dy * v.flflex
									v.nx:+dx*vms
									v.ny:+dy*vms
									vv.nx:-dx*vvms
									vv.ny:-dy*vvms
								EndIf
								EndRem
							EndIf
						ElseIf vvfluid And dist > 0 Then
							trr = v.siz + vv.flrad
							If dist <=trr Then
								flconstraint.Create(v:verlet,vv:verlet,vv.fllen+v.siz,vv.flflex,vv.flflexi,3)
							EndIf
							Rem
							'only the vv is a fluid
							len2 = vv.flrad + v.siz
							
							If dist# < (len2) Then
								len1 = vv.fllen + v.siz
								dx = dx / dist
								dy = dy / dist
								ddiff = len1-dist
								dx:* ddiff
								dy:* ddiff
								vvms = v.mass/tms
								vms = vv.mass/tms
								dx = dx * vv.flflex
								dy = dy * vv.flflex
								v.nx:+dx*vms
								v.ny:+dy*vms
								vv.nx:-dx*vvms
								vv.ny:-dy*vvms
							EndIf
							EndRem
						Else
							
							If dist# < totalr# And dist > 0 Then
								Local totmass#
								Local v1ofs:Float
								Local v2ofs:Float
								Local dmtr:Float
								Local diffx:Float
								Local diffy:Float
								
								Local collNormalAngle#=ATan2(-dy, -dx)
								
								Local nX#=Cos(collNormalAngle)
								Local nY#=Sin(collNormalAngle)
								
								
								Local vdx# = v.x-v.ox
								Local vdy# = v.y-v.oy
								
								Local vvdx# = vv.x-vv.ox
								Local vvdy# = vv.y-vv.oy
								
								
								Local a1# = vdx*nX  +  vdy*nY
								Local a2# = vvdx*nX +  vvdy*nY
															
								v.fricap = v.fricap - vv.friccr
								vv.fricap = vv.fricap - v.friccr
								
								
								totmass# = v.mass + vv.mass
								v1ofs# = (v.mass/totmass) * 2
								v2ofs# = (vv.mass/totmass) * 2
								
								Local optimisedP# = (2.0 * (a1-a2)) / (totmass#)
															
								dmtr# = dist#-totalr#							
								Diffx# = ( dmtr# ) * ( dx# / dist# )
								Diffy# = ( dmtr# ) * ( dy# / dist# )
								
								
								vdx = vdx - (optimisedP*vv.mass*nX)*(1-vv.friccr)
								vdy = vdy - (optimisedP*vv.mass*nY)*(1-vv.friccr)
								
								vvdx = vvdx + (optimisedP*v.mass*nX)*(1-v.friccr)
								vvdy = vvdy + (optimisedP*v.mass*nY)*(1-v.friccr)
															
								If v.active = True Then
									Local vx# = v.x-Diffx# *v2ofs* VerletDamper * .5
									Local vy# = v.y-Diffy# *v2ofs* VerletDamper * .5
									v.nx:+ vx-v.x
									v.ny:+ vy-v.y
									v.ox = vx-vdx
									v.oy = vy-vdy
								EndIf
							
								If vv.active = True Then
									Local vvx# = vv.x+Diffx# *v1ofs* VerletDamper * .5
									Local vvy# = vv.y+Diffy# *v1ofs* VerletDamper * .5
									vv.nx:+ vvx-vv.x
									vv.ny:+ vvy-vv.y
									vv.ox = vvx-vvdx
									vv.oy = vvy-vvdy
								EndIf
								
							EndIf
							
						EndIf
					Else
						ide = False
					EndIf
				EndIf
			EndIf
		EndIf

End Function

Function FindVerlet:verlet(name$)
	Local v:verlet
	For Local i:Int = 0 To verlcount-1
		v:verlet = verletarray:verlet[i]
		If v.name$ = name$ Then Return v:verlet
	Next
End Function